## hue 4.2.0+cdh6.3.2

=== Makefile ===
#
# Licensed to Cloudera, Inc. under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  Cloudera, Inc. licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# <<<< DEV ONLY
#
# Hue Build Process Overview
# =======================================
# This build process handles different types of builds:
#
#   - The production release build, the main task of which is to install
#     Desktop in the local system. The main build products are:
#
#     * build/env     - The virtual environment, where Desktop core
#               and various apps install into.
#
#   - The development build, which includes test and debugging tools. It
#     generates the production release, which boils down to a tarball that is
#     downloaded and installed. Additional build products include:
#
#     * build/release/prod  - The production tarball.
#     * build/docs    - General Desktop and SDK docs.
#
# We achieve this by selecting the parts to be distributed, and by stripping
# the Makefile's. Lines enclosed by the "DEV ONLY" marks are stripped for the
# general release. Targets are split/expanded using multiple rules and
# double-colon rules. The idea is to use almost identical build logic for the
# different flavours.
#
# Logic Flow
# ==========
# Here we summarize the flow of the build logic. Lines represent dependency.
#
#                  virtual-bootstrap.py
#                            |
#                  virtual-env (./env)
#                            |
#                      +----------+
#                      |          |
#                      |          V
#                      |       desktop  <--- recursive make in /desktop
#                      |          |
#                      |          V
#                      |         apps   <--- recursive make in /apps
#                      |
#                      V
#                 prod tarball   <-- selective copying into /build/release/...
#
#
# Application Build
# =================
# An app typically includes $(ROOT)/Makefile.sdk, which provides the standard
# targets and facilities. ROOT, which points to the Hue installation root, is
# always passed in.
#
# The application may also choose to not use the Hue build facilities. In that
# case, its Makefile still receives $(ROOT), and needs to provide several
# targets as specified in Makefile.sdk.
#
# END DEV ONLY >>>>

###################################
# Global variables
###################################
ROOT := $(realpath .)

include $(ROOT)/Makefile.vars.priv


###################################
# Error checking
###################################


.PHONY: default
default:
	@echo 'The build targets for Hue $(DESKTOP_VERSION) are:'
	@echo '  install     : Install at $$PREFIX ($(INSTALL_DIR)); need desktop'
	@echo '  apps        : Build and register all desktop apps; need desktop'
	@echo '  desktop     : Build desktop core only'
	@echo '  clean       : Remove desktop build products'
	@echo '  distclean   : Remove desktop and thirdparty build products'
# <<<< DEV ONLY
	@echo '  doc         : Build documentation'
	@echo '  prod        : Generate a tar file for production distribution'
	@echo '  locales     : Extract strings and update dictionary of each locale'
	@echo '  ace         : Builds the Ace Editor tool'
# END DEV ONLY >>>>

.PHONY: all
all: default

# <<<< DEV ONLY
include Makefile.tarball

###################################
# Build docs (unused)
###################################
.PHONY: docs
docs:
	@$(MAKE) -C docs
# END DEV ONLY >>>>

###################################
# Install parent POM
###################################
parent-pom:
	cd $(ROOT)/maven && mvn install $(MAVEN_OPTIONS)

.PHONY: parent-pom

###################################
# virtual-env
###################################
virtual-env: $(BLD_DIR_ENV)/stamp
$(BLD_DIR_ENV)/stamp:
	@echo "--- Creating virtual environment at $(BLD_DIR_ENV)"
	$(SYS_PYTHON) $(VIRTUAL_BOOTSTRAP) \
		$(VIRTUALENV_OPTS) --system-site-packages $(BLD_DIR_ENV)
	@touch $@
	@echo "--- $(BLD_DIR_ENV) ready"

.PHONY: virtual-env

###################################
# Build desktop
###################################
.PHONY: desktop

# <<<< DEV ONLY
desktop: parent-pom
# END DEV ONLY >>>>
desktop: virtual-env
	@$(MAKE) -C desktop


###################################
# Build apps
###################################
.PHONY: apps
apps: desktop
	@$(MAKE) npm-install
	@$(MAKE) -C $(APPS_DIR) env-install
	@$(MAKE) create-static

###################################
# Install binary dist
###################################
INSTALL_CORE_FILES = \
	Makefile* $(wildcard *.mk) \
	ext \
	tools/app_reg \
	tools/virtual-bootstrap \
	tools/enable-python27.sh \
	tools/relocatable.sh \
	VERS* LICENSE* README* webpack-stats*.json

.PHONY: install
install: virtual-env install-check install-core-structure install-desktop install-apps install-env

.PHONY: install-check
install-check:
	@if [ -n '$(wildcard $(INSTALL_DIR)/*)' ] ; then \
		echo 'ERROR: $(INSTALL_DIR) not empty. Cowardly refusing to continue.' ; \
		false ; \
	fi

.PHONY: install-core-structure
install-core-structure:
	@echo --- Installing core source structure...
	@mkdir -p $(INSTALL_DIR)
	@tar cf - $(INSTALL_CORE_FILES) | tar -C $(INSTALL_DIR) -xf -
	@# Add some variables to Makefile to make sure that our virtualenv
	@# in the install root is the same one we built from - this also
	@# disables the check for python-devel packages which are no longer
	@# needed
	@echo "SYS_PYTHON=$(ENV_PYTHON_VERSION)" > $(INSTALL_DIR)/Makefile.buildvars
	@echo "SKIP_PYTHONDEV_CHECK=1" >> $(INSTALL_DIR)/Makefile.buildvars

.PHONY: install-desktop
install-desktop:
	@echo --- Installing Desktop core...
	INSTALL_DIR=$(realpath $(INSTALL_DIR)) $(MAKE) -C desktop install

.PHONY: install-apps
install-apps:
	@echo '--- Installing Applications...'
	INSTALL_DIR=$(realpath $(INSTALL_DIR)) $(MAKE) -C apps install

.PHONY: install-env
install-env:
	@echo --- Creating new virtual environment
	$(MAKE) -C $(INSTALL_DIR) virtual-env
	@echo --- Setting up Desktop core
	$(MAKE) -C $(INSTALL_DIR)/desktop env-install
	@echo --- Setting up Applications
	$(MAKE) -C $(INSTALL_DIR)/apps env-install
	@echo --- Setting up Frontend assets
	cp $(ROOT)/package.json $(INSTALL_DIR)
	cp $(ROOT)/webpack.config*.js $(INSTALL_DIR)
	$(MAKE) -C $(INSTALL_DIR) npm-install


###################################
# Frontend and static assets
###################################

.PHONY: npm-install
npm-install:
	npm install
	npm run webpack
	npm run webpack-login
	npm run webpack-workers
	node_modules/.bin/removeNPMAbsolutePaths .
	rm -rf node_modules

.PHONY: create-static
create-static:
	./build/env/bin/hue collectstatic --noinput

# <<<< DEV ONLY
.PHONY: doc
doc:
	hugo --source docs/docs-site
# END DEV ONLY >>>>


###################################
# Internationalization
###################################

# <<<< DEV ONLY
.PHONY: locales
locales:
	@$(MAKE) -C desktop compile-locales
	@$(MAKE) -C apps compile-locales
# END DEV ONLY >>>>


###################################
# Ace Editor
###################################

# <<<< DEV ONLY
.PHONY: ace
ace:
	@cd tools/ace-editor && ./hue-ace.sh
# END DEV ONLY >>>>


###################################
# JISON Parser Generators
###################################

# <<<< DEV ONLY
.PHONY: global-search-parser
global-search-parser:
	@node tools/jison/generateParsers.js globalSearchParser

.PHONY: solr-all-parsers
solr-all-parsers:
	@node tools/jison/generateParsers.js solrQueryParser solrFormulaParser

.PHONY: solr-query-parser
solr-query-parser:
	@node tools/jison/generateParsers.js solrQueryParser

.PHONY: solr-formula-parser
solr-formula-parser:
	@node tools/jison/generateParsers.js solrFormulaParser

.PHONY: sql-all-parsers
sql-all-parsers:
	@node tools/jison/generateParsers.js sqlAutocompleteParser sqlSyntaxParser sqlStatementsParser

.PHONY: sql-autocomplete-parser
sql-autocomplete-parser:
	@node tools/jison/generateParsers.js sqlAutocompleteParser

.PHONY: sql-statement-parser
sql-statement-parser:
	@node tools/jison/generateParsers.js sqlStatementsParser

.PHONY: sql-syntax-parser
sql-syntax-parser:
	@node tools/jison/generateParsers.js sqlSyntaxParser
# END DEV ONLY >>>>

###################################
# Cleanup
###################################

.PHONY: clean
clean:
	@$(MAKE) -C desktop clean
	@$(MAKE) -C apps clean
# <<<< DEV ONLY
	@$(MAKE) -C docs clean
# END DEV ONLY >>>>
	@rm -rf $(BLD_DIR_ENV)
	@rm -rf $(STATIC_DIR)

#
# Note: It is important for clean targets to *ONLY* clean products of the
#       build, and not misc runtime generated files. Don't abuse Makefile.
#
.PHONY: distclean
distclean: clean
	@# Remove the other directories in build/
	@$(MAKE) -C desktop distclean
	@$(MAKE) -C apps distclean
	@rm -rf $(BLD_DIR)

.PHONY: ext-clean
ext-clean:
	@$(MAKE) -C desktop ext-clean
	@$(MAKE) -C apps ext-clean

# <<<< DEV ONLY
###############################################
# Misc (some used by automated test scripts)
###############################################

test:
	DESKTOP_DEBUG=1 $(ENV_PYTHON) $(BLD_DIR_BIN)/hue test fast --with-xunit

test-slow:
	DESKTOP_DEBUG=1 $(ENV_PYTHON) $(BLD_DIR_BIN)/hue test all --with-xunit --with-cover
	$(BLD_DIR_BIN)/coverage xml -i

start-dev:
	DESKTOP_DEBUG=1 $(ENV_PYTHON) $(BLD_DIR_BIN)/hue runserver_plus

devinstall:
	npm run devinstall

css:
	npm run less
# END DEV ONLY >>>>

=== debian/changelog ===
hue (4.2.0+cdh6.3.2-1605554) cloudera; urgency=medium

  * Please see git repos.

 -- MAINTAINER <jenkins@cldrn-ub1604-ec2-c5d-18xlarge-spotblk-10a0.vpc.cloudera.com>  Fri, 08 Nov 2019 05:15:57 -0800

=== debian/control ===
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

Source: hue
Section: misc
Priority: extra
Maintainer: Cloudera Inc. <https://issues.cloudera.org>
Build-Depends: debhelper (>= 7.0.50~), python2.4-dev | python2.5-dev | python2.6-dev | python2.7-dev, libxml2-dev, libxslt1-dev, zlib1g-dev, libsqlite3-dev, libldap2-dev, libsasl2-dev, libmysqlclient-dev, make, python-setuptools, libkrb5-dev, libgmp3-dev, libffi-dev, libtidy-dev, libssl-dev, libgmp-dev
Depends: hadoop, hive, bigtop-utils (>= 0.7), libsasl2-modules, libsasl2, libsqlite3, zlib1g, libxslt1, libxml2, libgmp3, libffi, libtidy, libssl, libgmp
Standards-Version: 3.8.0
Homepage: http://github.com/cloudera/hue

Package: hue
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, ${build:SYS-PYTHON}, libsasl2-modules-gssapi-mit, libxslt1.1, make
Conflicts: cloudera-desktop
Replaces: hue-about, hue-filebrowser, hue-help, hue-jobbrowser, hue-jobsub, hue-metastore, hue-oozie, hue-proxy, hue-shell, hue-useradmin, hue-beeswax, hue-common, hue-doc, hue-hbase, hue-impala, hue-pig, hue-plugins, hue-rdbms, hue-search, hue-security, hue-spark, hue-sqoop, hue-zookeeper, hue-server
Description: The hue metapackage
 Hue is a browser-based desktop interface for interacting with Hadoop.
 It supports a query editor, file browser, job tracker interface, cluster health monitor, and more.

=== debian/rules ===
#!/usr/bin/make -f
export COMPONENT_HASH=2f4242a6c67c15054154dc3eff3a11474d94f544
 HUE_VERSION=4.2.0+cdh6.3.2
 HUE_PATCHED_VERSION=4.2.0-cdh6.3.2
 HUE_BASE_VERSION=4.2.0
 HUE_RELEASE=1605554
 CDH_CUSTOMER_PATCH=p0
 CDH_PARCEL_CUSTOM_VERSION=4.2.0+cdh6.3.2-1605554.bionic
#
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# -*- makefile -*-

SHELL=/bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#Needed so that we do not encounter 
#ERROR ld.so object 'libfakeroot-sysv.so' from LD_PRELOAD cannot be preloaded
#and
#dpkg-shlibdeps: error: couldn't find library xxx  needed by yyy
# Note: LIB_FAKEROOT - Since some debian flavors has libfakeroot and others fakeroot we need to check which one
# actually works
LIB_FAKEROOT=$(shell dirname `dpkg -L fakeroot libfakeroot 2> /dev/null | grep 'libfakeroot.*.so' | head -n 1`)
export ORACLE_HOME=/opt/toolchain/oracle_11g_instantclient
export LD_LIBRARY_PATH:=$(LD_LIBRARY_PATH):$(LIB_FAKEROOT):$(ORACLE_HOME)

# Implicit targets
SHELL := /bin/bash

APPS=$(shell find apps -maxdepth 2 -name "src" -type d|cut -d "/" -f2|sort)

%:
	dh $@

override_dh_auto_build:
	env FULL_VERSION=${HUE_PATCHED_VERSION} bash -x debian/do-component-build -Dmaven.repo.local=${HOME}/.m2/repository${M2_REPO_SUFFIX}

override_dh_auto_install: build
	bash -x debian/install_hue.sh --build-dir=${PWD}/build/release/prod/hue-${HUE_PATCHED_VERSION} --prefix=${PWD}/debian/tmp
	cp ${PWD}/build/release/prod/hue-*/README ${PWD}/
	sed -e 's,^,build:,;' debian/tmp/usr/lib/hue/Makefile.buildvars \
	  | tr _ - >> debian/hue.substvars

override_dh_installinit:
	dh_installinit --name=hue --no-start

override_dh_fixperms:
	dh_fixperms
	chown -R hue:hue /var/log/hue /var/lib/hue /usr/lib/hue || true

override_dh_auto_test:
	@echo Tests are disabled

override_dh_builddeb:
	dh_builddeb -- -Zgzip

#Added to avoid errors of form
# dpkg-shlibdeps: error: no dependency information found for /opt/toolchain/oracle_11g_instantclient/libclntsh.so.11.1
#which pop up when building the cx_oracle egg
override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_strip_nondeterminism:
	# Disable dh_strip_nondeterminism to speed up the build

override_dh_strip:
	dh_strip --no-automatic-dbgsym
